<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FileSearchBasic StructType
 * @subpackage Structs
 */
class FileSearchBasic extends SearchRecordBasic
{
    /**
     * The availableWithoutLogin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $availableWithoutLogin;
    /**
     * The created
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $created;
    /**
     * The dateViewed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $dateViewed;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $description;
    /**
     * The documentSize
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $documentSize;
    /**
     * The externalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $externalId;
    /**
     * The externalIdString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $externalIdString;
    /**
     * The fileType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchEnumMultiSelectField
     */
    public $fileType;
    /**
     * The folder
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $folder;
    /**
     * The internalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $internalId;
    /**
     * The internalIdNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $internalIdNumber;
    /**
     * The isAvailable
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $isAvailable;
    /**
     * The isLink
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $isLink;
    /**
     * The modified
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $modified;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $name;
    /**
     * The owner
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $owner;
    /**
     * The url
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $url;
    /**
     * Constructor method for FileSearchBasic
     * @uses FileSearchBasic::setAvailableWithoutLogin()
     * @uses FileSearchBasic::setCreated()
     * @uses FileSearchBasic::setDateViewed()
     * @uses FileSearchBasic::setDescription()
     * @uses FileSearchBasic::setDocumentSize()
     * @uses FileSearchBasic::setExternalId()
     * @uses FileSearchBasic::setExternalIdString()
     * @uses FileSearchBasic::setFileType()
     * @uses FileSearchBasic::setFolder()
     * @uses FileSearchBasic::setInternalId()
     * @uses FileSearchBasic::setInternalIdNumber()
     * @uses FileSearchBasic::setIsAvailable()
     * @uses FileSearchBasic::setIsLink()
     * @uses FileSearchBasic::setModified()
     * @uses FileSearchBasic::setName()
     * @uses FileSearchBasic::setOwner()
     * @uses FileSearchBasic::setUrl()
     * @param \StructType\SearchBooleanField $availableWithoutLogin
     * @param \StructType\SearchDateField $created
     * @param \StructType\SearchDateField $dateViewed
     * @param \StructType\SearchStringField $description
     * @param \StructType\SearchLongField $documentSize
     * @param \StructType\SearchMultiSelectField $externalId
     * @param \StructType\SearchStringField $externalIdString
     * @param \StructType\SearchEnumMultiSelectField $fileType
     * @param \StructType\SearchMultiSelectField $folder
     * @param \StructType\SearchMultiSelectField $internalId
     * @param \StructType\SearchLongField $internalIdNumber
     * @param \StructType\SearchBooleanField $isAvailable
     * @param \StructType\SearchBooleanField $isLink
     * @param \StructType\SearchDateField $modified
     * @param \StructType\SearchStringField $name
     * @param \StructType\SearchMultiSelectField $owner
     * @param \StructType\SearchStringField $url
     */
    public function __construct(\StructType\SearchBooleanField $availableWithoutLogin = null, \StructType\SearchDateField $created = null, \StructType\SearchDateField $dateViewed = null, \StructType\SearchStringField $description = null, \StructType\SearchLongField $documentSize = null, \StructType\SearchMultiSelectField $externalId = null, \StructType\SearchStringField $externalIdString = null, \StructType\SearchEnumMultiSelectField $fileType = null, \StructType\SearchMultiSelectField $folder = null, \StructType\SearchMultiSelectField $internalId = null, \StructType\SearchLongField $internalIdNumber = null, \StructType\SearchBooleanField $isAvailable = null, \StructType\SearchBooleanField $isLink = null, \StructType\SearchDateField $modified = null, \StructType\SearchStringField $name = null, \StructType\SearchMultiSelectField $owner = null, \StructType\SearchStringField $url = null)
    {
        $this
            ->setAvailableWithoutLogin($availableWithoutLogin)
            ->setCreated($created)
            ->setDateViewed($dateViewed)
            ->setDescription($description)
            ->setDocumentSize($documentSize)
            ->setExternalId($externalId)
            ->setExternalIdString($externalIdString)
            ->setFileType($fileType)
            ->setFolder($folder)
            ->setInternalId($internalId)
            ->setInternalIdNumber($internalIdNumber)
            ->setIsAvailable($isAvailable)
            ->setIsLink($isLink)
            ->setModified($modified)
            ->setName($name)
            ->setOwner($owner)
            ->setUrl($url);
    }
    /**
     * Get availableWithoutLogin value
     * @return \StructType\SearchBooleanField|null
     */
    public function getAvailableWithoutLogin()
    {
        return $this->availableWithoutLogin;
    }
    /**
     * Set availableWithoutLogin value
     * @param \StructType\SearchBooleanField $availableWithoutLogin
     * @return \StructType\FileSearchBasic
     */
    public function setAvailableWithoutLogin(\StructType\SearchBooleanField $availableWithoutLogin = null)
    {
        $this->availableWithoutLogin = $availableWithoutLogin;
        return $this;
    }
    /**
     * Get created value
     * @return \StructType\SearchDateField|null
     */
    public function getCreated()
    {
        return $this->created;
    }
    /**
     * Set created value
     * @param \StructType\SearchDateField $created
     * @return \StructType\FileSearchBasic
     */
    public function setCreated(\StructType\SearchDateField $created = null)
    {
        $this->created = $created;
        return $this;
    }
    /**
     * Get dateViewed value
     * @return \StructType\SearchDateField|null
     */
    public function getDateViewed()
    {
        return $this->dateViewed;
    }
    /**
     * Set dateViewed value
     * @param \StructType\SearchDateField $dateViewed
     * @return \StructType\FileSearchBasic
     */
    public function setDateViewed(\StructType\SearchDateField $dateViewed = null)
    {
        $this->dateViewed = $dateViewed;
        return $this;
    }
    /**
     * Get description value
     * @return \StructType\SearchStringField|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \StructType\SearchStringField $description
     * @return \StructType\FileSearchBasic
     */
    public function setDescription(\StructType\SearchStringField $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get documentSize value
     * @return \StructType\SearchLongField|null
     */
    public function getDocumentSize()
    {
        return $this->documentSize;
    }
    /**
     * Set documentSize value
     * @param \StructType\SearchLongField $documentSize
     * @return \StructType\FileSearchBasic
     */
    public function setDocumentSize(\StructType\SearchLongField $documentSize = null)
    {
        $this->documentSize = $documentSize;
        return $this;
    }
    /**
     * Get externalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param \StructType\SearchMultiSelectField $externalId
     * @return \StructType\FileSearchBasic
     */
    public function setExternalId(\StructType\SearchMultiSelectField $externalId = null)
    {
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get externalIdString value
     * @return \StructType\SearchStringField|null
     */
    public function getExternalIdString()
    {
        return $this->externalIdString;
    }
    /**
     * Set externalIdString value
     * @param \StructType\SearchStringField $externalIdString
     * @return \StructType\FileSearchBasic
     */
    public function setExternalIdString(\StructType\SearchStringField $externalIdString = null)
    {
        $this->externalIdString = $externalIdString;
        return $this;
    }
    /**
     * Get fileType value
     * @return \StructType\SearchEnumMultiSelectField|null
     */
    public function getFileType()
    {
        return $this->fileType;
    }
    /**
     * Set fileType value
     * @param \StructType\SearchEnumMultiSelectField $fileType
     * @return \StructType\FileSearchBasic
     */
    public function setFileType(\StructType\SearchEnumMultiSelectField $fileType = null)
    {
        $this->fileType = $fileType;
        return $this;
    }
    /**
     * Get folder value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getFolder()
    {
        return $this->folder;
    }
    /**
     * Set folder value
     * @param \StructType\SearchMultiSelectField $folder
     * @return \StructType\FileSearchBasic
     */
    public function setFolder(\StructType\SearchMultiSelectField $folder = null)
    {
        $this->folder = $folder;
        return $this;
    }
    /**
     * Get internalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param \StructType\SearchMultiSelectField $internalId
     * @return \StructType\FileSearchBasic
     */
    public function setInternalId(\StructType\SearchMultiSelectField $internalId = null)
    {
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get internalIdNumber value
     * @return \StructType\SearchLongField|null
     */
    public function getInternalIdNumber()
    {
        return $this->internalIdNumber;
    }
    /**
     * Set internalIdNumber value
     * @param \StructType\SearchLongField $internalIdNumber
     * @return \StructType\FileSearchBasic
     */
    public function setInternalIdNumber(\StructType\SearchLongField $internalIdNumber = null)
    {
        $this->internalIdNumber = $internalIdNumber;
        return $this;
    }
    /**
     * Get isAvailable value
     * @return \StructType\SearchBooleanField|null
     */
    public function getIsAvailable()
    {
        return $this->isAvailable;
    }
    /**
     * Set isAvailable value
     * @param \StructType\SearchBooleanField $isAvailable
     * @return \StructType\FileSearchBasic
     */
    public function setIsAvailable(\StructType\SearchBooleanField $isAvailable = null)
    {
        $this->isAvailable = $isAvailable;
        return $this;
    }
    /**
     * Get isLink value
     * @return \StructType\SearchBooleanField|null
     */
    public function getIsLink()
    {
        return $this->isLink;
    }
    /**
     * Set isLink value
     * @param \StructType\SearchBooleanField $isLink
     * @return \StructType\FileSearchBasic
     */
    public function setIsLink(\StructType\SearchBooleanField $isLink = null)
    {
        $this->isLink = $isLink;
        return $this;
    }
    /**
     * Get modified value
     * @return \StructType\SearchDateField|null
     */
    public function getModified()
    {
        return $this->modified;
    }
    /**
     * Set modified value
     * @param \StructType\SearchDateField $modified
     * @return \StructType\FileSearchBasic
     */
    public function setModified(\StructType\SearchDateField $modified = null)
    {
        $this->modified = $modified;
        return $this;
    }
    /**
     * Get name value
     * @return \StructType\SearchStringField|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param \StructType\SearchStringField $name
     * @return \StructType\FileSearchBasic
     */
    public function setName(\StructType\SearchStringField $name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get owner value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getOwner()
    {
        return $this->owner;
    }
    /**
     * Set owner value
     * @param \StructType\SearchMultiSelectField $owner
     * @return \StructType\FileSearchBasic
     */
    public function setOwner(\StructType\SearchMultiSelectField $owner = null)
    {
        $this->owner = $owner;
        return $this;
    }
    /**
     * Get url value
     * @return \StructType\SearchStringField|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param \StructType\SearchStringField $url
     * @return \StructType\FileSearchBasic
     */
    public function setUrl(\StructType\SearchStringField $url = null)
    {
        $this->url = $url;
        return $this;
    }
}
